﻿
Imports LC.Midi


Public Class Form1

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Me.Left = -9999
        Me.Opacity = 0
        EventsAreEnabled = False
        MemoryMappedFile_Init()
        '
        ToolTips_Init()
        '
        Load_INI()
        SetParams()
        ShowOutDeviceName()
        ShowInDeviceName()
        OpenOutputDevice()
        OpenInputDevice()
        '
        mtimer = New MilliTimer()
        mtimer.Interval = 5
        mtimer.Start()
        '
        Timer1.Interval = 100
        Timer1.Start()
        '
        Text = AppTitleAndVersion("")
        EventsAreEnabled = True
        Me.Opacity = 100
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Me.Visible = False
        EventsAreEnabled = False
        CloseOutputDevice()
        CloseInputDevice()
        If mtimer IsNot Nothing Then mtimer.Stop()
        Save_INI()
        'End
    End Sub

    Private Sub Form_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Exit Sub
        LimitFormPosition(Me)
    End Sub


    ' ====================================================================================================
    '  Params
    ' ====================================================================================================
    Private stm_FirstSlot As Int32
    Private stm_ConsecutiveSlots As Int32
    Private stm_NoteTriggerValue As Int32
    Private stm_VelocityMultiplier As Single
    Private stm_CntrFirstSlot As Int32
    Private stm_CntrConsecutive As Int32
    Private stm_MidiChannel As Int32
    Private stm_FirstMidiNote As Int32
    Private mts_FirstSlot As Int32
    Private mts_CntrFirstSlot As Int32
    Private mts_MidiChannel As Int32
    Private mts_MidiNote As Int32

    Private Sub Params_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_stm_FirstSlot.LostFocus, _
                                                                                              txt_stm_ConsecutiveSlots.LostFocus, _
                                                                                              txt_stm_NoteTriggerValue.LostFocus, _
                                                                                              txt_stm_VelocityMultiplier.LostFocus, _
                                                                                              txt_stm_CntrFirstSlot.LostFocus, _
                                                                                              txt_stm_CntrConsecutive.LostFocus, _
                                                                                              txt_stm_MidiChannel.LostFocus, _
                                                                                              txt_stm_FirstMidiNote.LostFocus, _
                                                                                              txt_mts_FirstSlot.LostFocus, _
                                                                                              txt_mts_CntrFirstSlot.LostFocus, _
                                                                                              txt_mts_MidiChannel.LostFocus, _
                                                                                              txt_mts_FirstMidiNote.LostFocus
        If Not EventsAreEnabled Then Exit Sub
        Save_INI()
    End Sub

    Private Sub txt_stm_FirstSlot_TextChanged(ByVal sender As System.Object, _
                                              ByVal e As System.EventArgs) Handles txt_stm_FirstSlot.TextChanged, _
                                                                                   txt_stm_ConsecutiveSlots.TextChanged, _
                                                                                   txt_stm_NoteTriggerValue.TextChanged, _
                                                                                   txt_stm_VelocityMultiplier.TextChanged, _
                                                                                   txt_stm_CntrFirstSlot.TextChanged, _
                                                                                   txt_stm_CntrConsecutive.TextChanged, _
                                                                                   txt_stm_MidiChannel.TextChanged, _
                                                                                   txt_stm_FirstMidiNote.TextChanged, _
                                                                                   txt_mts_FirstSlot.TextChanged, _
                                                                                   txt_mts_CntrFirstSlot.TextChanged, _
                                                                                   txt_mts_MidiChannel.TextChanged, _
                                                                                   txt_mts_FirstMidiNote.TextChanged

        If Not EventsAreEnabled Then Exit Sub
        SetParams()
    End Sub

    Private Sub SetParams()
        stm_FirstSlot = txt_stm_FirstSlot.NumericValueInteger
        stm_ConsecutiveSlots = txt_stm_ConsecutiveSlots.NumericValueInteger
        stm_NoteTriggerValue = txt_stm_NoteTriggerValue.NumericValueInteger
        stm_VelocityMultiplier = CSng(txt_stm_VelocityMultiplier.NumericValue)
        stm_CntrFirstSlot = txt_stm_CntrFirstSlot.NumericValueInteger
        stm_CntrConsecutive = txt_stm_CntrConsecutive.NumericValueInteger
        stm_MidiChannel = txt_stm_MidiChannel.NumericValueInteger
        stm_FirstMidiNote = txt_stm_FirstMidiNote.NumericValueInteger
        mts_FirstSlot = txt_mts_FirstSlot.NumericValueInteger
        mts_CntrFirstSlot = txt_mts_CntrFirstSlot.NumericValueInteger
        mts_MidiChannel = txt_mts_MidiChannel.NumericValueInteger
        mts_MidiNote = txt_mts_FirstMidiNote.NumericValueInteger
    End Sub

    ' ==============================================================================================================
    '   ToolTips
    ' ==============================================================================================================
    Private ttp1 As ToolTip
    Private Sub ToolTips_Init()
        ttp1 = New ToolTip
        ttp1.ShowAlways = True
        ttp1.UseAnimation = True
        ttp1.UseFading = True
        ttp1.IsBalloon = True
        ttp1.AutoPopDelay = 32700
        ttp1.InitialDelay = 700
        ttp1.ReshowDelay = 500
        ' --------------------------------------------------------------- Add here Controls and ToolTip-Text
        ttp1.SetToolTip(txt_stm_FirstSlot, _
                " First slot" & vbCrLf & _
                " - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -" & vbCrLf & _
                " Sets the first Slot used to manage MIDI data.")
        ttp1.SetToolTip(txt_stm_ConsecutiveSlots, _
                " Consecutive slots" & vbCrLf & _
                " - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -" & vbCrLf & _
                " Sets the number of consecutive Slots used to transmit MIDI data.")
        ttp1.SetToolTip(txt_stm_NoteTriggerValue, _
                " Note trigger value" & vbCrLf & _
                " - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -" & vbCrLf & _
                " Sets the minimum value to activate a Note ON")
        ttp1.SetToolTip(txt_stm_VelocityMultiplier, _
                " Velocity multiplier" & vbCrLf & _
                " - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -" & vbCrLf & _
                " Sets the amount of velocity," & vbCrLf & _
                " useful when slots values are too low or too high.")
        ttp1.SetToolTip(txt_stm_CntrFirstSlot, _
                " CNTR first slot" & vbCrLf & _
                " - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -" & vbCrLf & _
                " Sets the position of the first Slot managing MIDI Controllers data.")
        ttp1.SetToolTip(txt_stm_CntrConsecutive, _
                " CNTR consecutive slots" & vbCrLf & _
                " - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -" & vbCrLf & _
                " Indicates the number of the consecutive Slots, dedicated to  MIDI Controllers.")
        ttp1.SetToolTip(txt_stm_MidiChannel, _
                " Midi channel" & vbCrLf & _
                " - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -" & vbCrLf & _
                " Indicates which MIDI Channel will transmit data.")
        ttp1.SetToolTip(txt_stm_FirstMidiNote, _
                " First midi note" & vbCrLf & _
                " - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -" & vbCrLf & _
                " Sets the first MIDI Note played.")
        ttp1.SetToolTip(txt_mts_FirstSlot, _
                " First slot" & vbCrLf & _
                " - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -" & vbCrLf & _
                " It is the first of the consecutive Slots, dedicated to MIDI data collection.")
        ttp1.SetToolTip(txt_mts_CntrFirstSlot, _
                " CNTR first slot" & vbCrLf & _
                " - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -" & vbCrLf & _
                " The first Slot in use by coming MIDI Control data.")
        ttp1.SetToolTip(txt_mts_MidiChannel, _
                " Midi channel" & vbCrLf & _
                " - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -" & vbCrLf & _
                " Sets the Channel of MIDI reception. ( 0 = ALL )")
        ttp1.SetToolTip(txt_mts_FirstMidiNote, _
                " Midi note" & vbCrLf & _
                " - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -" & vbCrLf & _
                " The first coming MIDI Note that will be sent to Slots.")
    End Sub

    ' --------------------- this corrects the XP bug that causes tooltip disappearing for ever 
    Private Sub controls_MouseEnter(ByVal sender As Object, _
                                   ByVal e As System.EventArgs) Handles txt_stm_FirstSlot.MouseEnter, _
                                                                        txt_stm_ConsecutiveSlots.MouseEnter, _
                                                                        txt_stm_NoteTriggerValue.MouseEnter, _
                                                                        txt_stm_VelocityMultiplier.MouseEnter, _
                                                                        txt_stm_CntrFirstSlot.MouseEnter, _
                                                                        txt_stm_CntrConsecutive.MouseEnter, _
                                                                        txt_stm_MidiChannel.MouseEnter, _
                                                                        txt_stm_FirstMidiNote.MouseEnter, _
                                                                        txt_mts_FirstSlot.MouseEnter, _
                                                                        txt_mts_CntrFirstSlot.MouseEnter, _
                                                                        txt_mts_MidiChannel.MouseEnter, _
                                                                        txt_mts_FirstMidiNote.MouseEnter
        ttp1.Active = False
        ttp1.Active = True
    End Sub


    ' ====================================================================================================
    '  Playing notes array
    ' ====================================================================================================
    Private PlayingNotes As Hashtable = New Hashtable
    Private Sub PlayingNotes_ReleaseAllNotes()
        For n As Int32 = 0 To 127
            PlayingNotes_Release(n)
        Next
    End Sub
    Private Sub PlayingNotes_Release(ByVal n As Int32)
        If PlayingNotes.Contains(n) Then
            PlayingNotes.Remove(n)
            Dim message As ChannelMessage = New ChannelMessage(ChannelCommand.NoteOff, stm_MidiChannel - 1, n)
            MidiOutDevice.Send(message)
        End If
    End Sub
    ' -------------------------------------------------------------------- Press - only a initial trigger 
    Private Sub PlayingNotes_Press(ByVal n As Int32, ByVal vol As Int32)
        If Not PlayingNotes.Contains(n) Then
            PlayingNotes.Add(n, 0)
            If vol < 0 Then vol = 0
            If vol > 127 Then vol = 127
            Dim message As ChannelMessage = New ChannelMessage(ChannelCommand.NoteOn, stm_MidiChannel - 1, n, vol)
            MidiOutDevice.Send(message)
            StmArrowLight = True
        End If
    End Sub
    ' ----------------------------------------------------------- Retrigger - changing valume of notes ON
    'Private Sub PlayingNotes_Retrigger(ByVal n As Int32, ByVal vol As Int32)
    '    If vol < 0 Then vol = 0
    '    If vol > 127 Then vol = 127
    '    Dim message As ChannelMessage = New ChannelMessage(ChannelCommand.NoteOn, 0, n, vol)
    '    '
    '    If Not PlayingNotes.Contains(n) Then
    '        PlayingNotes.Add(n, 0)
    '    End If
    'End Sub



    ' ====================================================================================================
    '   OUTPUT MIDI DEVICE
    ' ====================================================================================================
    Friend OutputDeviceID As Int32
    Private MidiOutDevice As OutputDevice
    Private Function OutputDeviceName(ByVal id As Int32) As String
        If id < 0 Or id >= OutputDevice.DeviceCount Then Return "Unused"
        Dim cap As MidiOutCaps = OutputDevice.GetDeviceCapabilities(id)
        Return cap.name
    End Function
    Private Sub ShowOutDeviceName()
        Combo_Init(cmb_OutputDevice, OutputDeviceName(OutputDeviceID))
    End Sub
    Private Sub OpenOutputDevice()
        CloseOutputDevice()
        If OutputDeviceID < 0 Or OutputDeviceID >= OutputDevice.DeviceCount Then Return
        MidiOutDevice = New OutputDevice(OutputDeviceID)
    End Sub
    Private Sub CloseOutputDevice()
        If MidiOutDevice IsNot Nothing Then
            MidiOutDevice.Close()
            MidiOutDevice = Nothing
        End If
    End Sub


    ' ====================================================================================================
    '  INPUT MIDI DEVICE
    ' ====================================================================================================
    Friend InputDeviceID As Int32
    Private WithEvents MidiInDevice As InputDevice
    Private Function InputDeviceName(ByVal id As Int32) As String
        If id < 0 Or id >= InputDevice.DeviceCount Then Return "Unused"
        Dim cap As MidiInCaps = InputDevice.GetDeviceCapabilities(id)
        Return cap.name
    End Function
    Private Sub ShowInDeviceName()
        Combo_Init(cmb_InputDevice, InputDeviceName(InputDeviceID))
    End Sub
    Private Sub OpenInputDevice()
        CloseInputDevice()
        If InputDeviceID < 0 Or InputDeviceID >= InputDevice.DeviceCount Then Return
        MidiInDevice = New InputDevice(InputDeviceID)
        MidiInDevice.StartRecording()
    End Sub
    Private Sub CloseInputDevice()
        If MidiInDevice IsNot Nothing Then
            MidiInDevice.StopRecording()
            MidiInDevice.Close()
            MidiInDevice = Nothing
        End If
    End Sub


    ' ====================================================================================================
    '   OUTPUT DEVICE COMBO
    ' ====================================================================================================
    Private Sub cmb_OutputDevice_DropDown(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_OutputDevice.DropDown
        If OutputDevice.DeviceCount > 0 Then
            Dim oldname As String = cmb_OutputDevice.Items(0).ToString
            cmb_OutputDevice.ItemHeight = 16
            cmb_OutputDevice.Items.Clear()
            cmb_OutputDevice.Items.Add("Unused")
            For i As Integer = 0 To OutputDevice.DeviceCount - 1
                cmb_OutputDevice.Items.Add(OutputDeviceName(i))
            Next
            If OutputDeviceID >= 0 And OutputDeviceID < cmb_OutputDevice.Items.Count Then
                cmb_OutputDevice.SelectedIndex = OutputDeviceID + 1
            End If
            Combo_SetIndex_FromString(cmb_OutputDevice, oldname)
        End If
    End Sub
    Private Sub cmb_OutputDevice_DropDownClosed(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_OutputDevice.DropDownClosed
        cmb_OutputDevice.ItemHeight = 12
        Combo_Init(cmb_OutputDevice, cmb_OutputDevice.Text)
    End Sub
    Private Sub cmb_OutputDevice_SelectionChangeCommitted(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_OutputDevice.SelectionChangeCommitted
        OutputDeviceID = cmb_OutputDevice.SelectedIndex - 1
        OpenOutputDevice()
        Save_INI()
    End Sub


    ' ====================================================================================================
    '   INPUT DEVICE COMBO
    ' ====================================================================================================
    Private Sub cmb_InputDevice_DropDown(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_InputDevice.DropDown
        If InputDevice.DeviceCount > 0 Then
            Dim oldname As String = cmb_InputDevice.Items(0).ToString
            cmb_InputDevice.ItemHeight = 16
            cmb_InputDevice.Items.Clear()
            cmb_InputDevice.Items.Add("Unused")
            For i As Integer = 0 To InputDevice.DeviceCount - 1
                cmb_InputDevice.Items.Add(InputDeviceName(i))
            Next
            If InputDeviceID >= 0 And InputDeviceID < cmb_InputDevice.Items.Count Then
                cmb_InputDevice.SelectedIndex = InputDeviceID - 1
            End If
            Combo_SetIndex_FromString(cmb_InputDevice, oldname)
        End If
    End Sub
    Private Sub cmb_InputDevice_DropDownClosed(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_InputDevice.DropDownClosed
        cmb_InputDevice.ItemHeight = 12
        Combo_Init(cmb_InputDevice, cmb_InputDevice.Text)
    End Sub
    Private Sub cmb_InputDevice_SelectionChangeCommitted(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_InputDevice.SelectionChangeCommitted
        InputDeviceID = cmb_InputDevice.SelectedIndex - 1
        OpenInputDevice()
        Save_INI()
    End Sub



    ' ====================================================================================================
    '  MIXED FUNCTIONS
    ' ====================================================================================================
    'Private Sub SendBendMessage(ByVal bend As Single)
    '    ' -----------------------------------------------
    '    '  Bend value
    '    ' ------------------------------------------------------------
    '    ' The two bytes combined together form a 14-bit value. 
    '    ' First byte - bits 0 to 6 = bits 0 to 6 of the 14-bit value 
    '    ' Second byte - bits 0 to 6 = bits 7 to 13 of the 14-bit value
    '    ' ------------------------------------------------------------
    '    Dim b As Int32 = CInt(16383 * bend)
    '    Dim m As ChannelMessage = New ChannelMessage(ChannelCommand.PitchWheel, _
    '                                                 0, _
    '                                                 b And 127, _
    '                                                 b >> 7)
    '    'synth1.ProcessChannelMessage(m)
    'End Sub


    ' ====================================================================================================
    '  Slow timer for User Interface
    ' ====================================================================================================
    Private StmArrowLight As Boolean
    Private MtsArrowLight As Boolean
    Private StmArrowCounter As Int32
    Private MtsArrowCounter As Int32

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        If Not EventsAreEnabled Then Return
        If StmArrowLight Then
            If StmArrowCounter = 0 Then
                pbox_stm.Image = My.Resources.A2R
                StmArrowCounter = 5
            Else
                StmArrowCounter -= 1
                If StmArrowCounter = 0 Then
                    pbox_stm.Image = My.Resources.A1R
                    StmArrowLight = False
                End If
            End If
        End If
        If MtsArrowLight Then
            If MtsArrowCounter = 0 Then
                pbox_mts.Image = My.Resources.A2L
                MtsArrowCounter = 5
            Else
                MtsArrowCounter -= 1
                If MtsArrowCounter = 0 Then
                    pbox_mts.Image = My.Resources.A1L
                    MtsArrowLight = False
                End If
            End If
        End If
    End Sub


    ' ====================================================================================================
    '  Polling with MilliTimer for Slots to Midi
    ' ====================================================================================================
    Private WithEvents mtimer As MilliTimer
    Private Sub MilliTimerElapsed_ThreadSafe() Handles mtimer.MilliTimerElapsed
        Try
            Me.Invoke(New Action(Of Int32)(AddressOf MilliTimerElapsed), 0)
        Catch
        End Try
    End Sub
    Private Sub MilliTimerElapsed(ByVal n As Int32)
        PollSlots()
        'TestTime()
    End Sub
    'Private Sub TestTime()
    '    Static t As Double = 0
    '    t = t + mtimer.Interval
    '    If t >= 1000 Then
    '        t = 0
    '        'Beep()
    '        Me.Text = DateTime.Now.Millisecond.ToString
    '    End If
    'End Sub
    Friend Sub PollSlots()
        If MidiOutDevice Is Nothing Then Return
        Dim v As Single
        Dim s As Int32
        Dim pressed As Boolean = False
        For n As Int32 = 0 To stm_ConsecutiveSlots - 1
            s = stm_FirstSlot + n
            v = ReadSlot_NoNan(s)
            If v > stm_NoteTriggerValue Then
                Dim vol As Int32 = CInt(v / 1000.0F * 128 * stm_VelocityMultiplier)
                PlayingNotes_Press(stm_FirstMidiNote + n, vol)
            Else
                PlayingNotes_Release(stm_FirstMidiNote + n)
            End If
        Next
        Dim cv As Int32
        For n As Int32 = 0 To stm_CntrConsecutive - 1
            s = stm_CntrFirstSlot + n
            v = ReadSlot_NoNan(s)
            cv = CInt(v / 1000.0F * 128)
            If cv < 0 Then cv = 0
            If cv > 127 Then cv = 127
            If cv <> ControlValues(n) Then
                ControlValues(n) = cv
                Dim message As ChannelMessage = New ChannelMessage(ChannelCommand.Controller, stm_MidiChannel - 1, n, cv)
                MidiOutDevice.Send(message)
                StmArrowLight = True
            End If
        Next
    End Sub
    Private ControlValues(128) As Int32


    ' ====================================================================================================
    '  Midi to Slots
    ' ====================================================================================================
    Private Sub MidiInDevice_ChannelMessageReceived(ByVal sender As Object, ByVal e As LC.Midi.ChannelMessageEventArgs) Handles MidiInDevice.ChannelMessageReceived
        If mts_MidiChannel <> 0 AndAlso e.Message.MidiChannel + 1 <> mts_MidiChannel Then Return
        Select Case e.Message.Command
            Case ChannelCommand.NoteOn
                Dim slot As Int32 = mts_FirstSlot - mts_MidiNote + e.Message.Data1
                WriteSlot(slot, e.Message.Data2 * 1000 / 127.0F)
            Case ChannelCommand.NoteOff
                Dim slot As Int32 = mts_FirstSlot - mts_MidiNote + e.Message.Data1
                WriteSlot(slot, 0)
            Case ChannelCommand.Controller
                Dim slot As Int32 = mts_CntrFirstSlot + e.Message.Data1
                WriteSlot(slot, e.Message.Data2 * 1000 / 127.0F)
            Case ChannelCommand.PitchWheel
            Case ChannelCommand.PolyPressure
            Case ChannelCommand.ProgramChange
            Case ChannelCommand.ChannelPressure
        End Select
        MtsArrowLight = True
        'Beep()
    End Sub
    Private Sub MidiInDevice_SysCommonMessageReceived(ByVal sender As Object, ByVal e As LC.Midi.SysCommonMessageEventArgs) Handles MidiInDevice.SysCommonMessageReceived
        'Beep()
    End Sub
    Private Sub MidiInDevice_SysExMessageReceived(ByVal sender As Object, ByVal e As LC.Midi.SysExMessageEventArgs) Handles MidiInDevice.SysExMessageReceived
        'Beep()
    End Sub
    Private Sub MidiInDevice_SysRealtimeMessageReceived(ByVal sender As Object, ByVal e As LC.Midi.SysRealtimeMessageEventArgs) Handles MidiInDevice.SysRealtimeMessageReceived
        'Beep()
    End Sub

End Class