

Public Class MidiEvent

    Private m_owner As Object = Nothing
    Private m_absoluteTicks As Integer
    Private message As IMidiMessage
    Private m_next As MidiEvent = Nothing
    Private m_previous As MidiEvent = Nothing

    Friend Sub New(ByVal owner As Object, ByVal absoluteTicks As Integer, ByVal message As IMidiMessage)
        If owner Is Nothing Then
            Throw New ArgumentNullException("owner")
        ElseIf absoluteTicks < 0 Then
            Throw New ArgumentOutOfRangeException("absoluteTicks", absoluteTicks, "Absolute ticks out of range.")
        ElseIf message Is Nothing Then
            Throw New ArgumentNullException("e")
        End If

        Me.m_owner = owner
        Me.m_absoluteTicks = absoluteTicks
        Me.message = message
    End Sub

    Friend Sub SetAbsoluteTicks(ByVal absoluteTicks As Integer)
        Me.m_absoluteTicks = absoluteTicks
    End Sub

    Friend ReadOnly Property Owner() As Object
        Get
            Return m_owner
        End Get
    End Property

    Public ReadOnly Property AbsoluteTicks() As Integer
        Get
            Return m_absoluteTicks
        End Get
    End Property

    Public ReadOnly Property DeltaTicks() As Integer
        Get
            Dim _deltaTicks As Integer

            If Previous IsNot Nothing Then
                _deltaTicks = AbsoluteTicks - m_previous.AbsoluteTicks
            Else
                _deltaTicks = AbsoluteTicks
            End If

            Return _deltaTicks
        End Get
    End Property

    Public ReadOnly Property MidiMessage() As IMidiMessage
        Get
            Return message
        End Get
    End Property

    Friend Property [Next]() As MidiEvent
        Get
            Return m_next
        End Get
        Set(ByVal value As MidiEvent)
            m_next = Value
        End Set
    End Property

    Friend Property Previous() As MidiEvent
        Get
            Return m_previous
        End Get
        Set(ByVal value As MidiEvent)
            m_previous = Value
        End Set
    End Property

End Class
