

Imports System.Windows.Forms

Namespace UI
	Public Partial Class InputDeviceDialog
		Inherits Form
		Private m_inputDeviceID As Integer = 0

		Public Sub New()
			InitializeComponent()

			If InputDevice.DeviceCount > 0 Then
				For i As Integer = 0 To InputDevice.DeviceCount - 1
					inputComboBox.Items.Add(InputDevice.GetDeviceCapabilities(i).name)
				Next
				inputComboBox.SelectedIndex = m_inputDeviceID
			End If
		End Sub

		Protected Overloads Overrides Sub OnShown(e As EventArgs)
			If InputDevice.DeviceCount > 0 Then
				inputComboBox.SelectedIndex = m_inputDeviceID
			End If
			MyBase.OnShown(e)
		End Sub

        Private Sub OkButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OkButton.Click
            If InputDevice.DeviceCount > 0 Then
                m_inputDeviceID = inputComboBox.SelectedIndex
            End If
            DialogResult = DialogResult.OK
        End Sub

        Private Sub ButtonCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonCancel.Click
            DialogResult = DialogResult.Cancel
        End Sub

		Public Property InputDeviceID() As Integer
			Get
                Return m_inputDeviceID
            End Get
			Set
                m_inputDeviceID = Value
            End Set
		End Property

    End Class

End Namespace
